#ifndef __CAMERA_HPP
#define __CAMERA_HPP

#include <SophiaFramework.hpp>


#define PICTURE_WIDTH   240     // JŎ擾摜̕
#define PICTURE_HEIGHT  320     // JŎ擾摜̍


SFMTYPEDEFCLASS(Camera)
class Camera {
SFMSEALCOPY(Camera)
public:
    enum StatusEnum {       // J̓
        STATUS_PREVIEW,     // vr[[hœ쒆
        STATUS_FRAME,       // vr[̐Vȃt[`悳ꂽ
        STATUS_RECORD,      // XibvVbgBeJn
        STATUS_ENCODE       // XibvVbg̎Be
    };

private:
    typedef Void (*NotifySPP)(StatusEnum status, SFCError error, VoidPtr reference);

private:
    SFBCameraSmp _camera;   // Ĵ
    StatusEnum _status;     // J̏ԕۑp
    SFBBitmapSmp _bitmap;   // JŎ擾rbg}bv
    SFXRectangle _rect;     // ʏ̃J摜\̈
    AEEMediaData _mediaData;    // fBA f[^
    ACharPtr _mimeType;     // MIME TYPE
    Bool _previewable;      // ݃vr[\ǂ
    Bool _recordable;       // XibvVbg[hł̎Be\ǂ
    NotifySPP _spp;         // ̃NXgpĂNX́AJɊւR[obN֐
    VoidPtr _reference;     // ̃NXgpĂNX̃R[obN֐ɓnf[^ւ̎Q

    Void AfterSnapshot(Void);   // Xibv VbgBȅ

public:
    Camera(Void);                               // RXgN^
    virtual ~Camera(Void);                      // fBXgN^
    SFCError Initialize(SFXRectangleConstRef rect, NotifySPP spp, VoidPtr reference);   // J̏s
    SFCError Preview(Void);                     // vr[Jn
    SFCError Record(Void);                      // XibvVbg[hJn
    Void Suspend(Void);                         // J̏I
    SFCError Resume(Void);                      // J̊{Iȏ
    Void Terminate(Void);                       // n
    SFBBitmapSmpRef GetBitmap(Void) {   // Beꂽrbg}bv擾
        return _bitmap;
    }
    Bool IsPreviewable(Void) const {    // ݃vr[\ǂׂ
        return _previewable;
    }
    static Void OnCameraSHP(VoidPtr reference, AEECameraNotify* notify);    // R[obNnh(_~[)
    Void OnCamera(AEECameraNotify* notify);     // R[obNnh()
    SInt16 GetBrightness(Void);         // ݂̃J̖邳擾
    Bool GetBrightnessRange(SInt16Ptr minimum, SInt16Ptr maximum);  // Jɐݒ\Ȗ邳͈̔͂擾
    Void SetBrightness(SInt16 value);   // J̖邳ݒ肷
    SInt16 GetZoom(Void);   // ݂̃Y[l擾
    Bool GetZoomRange(SInt16Ptr mininum, SInt16Ptr maximum);    // ݒ\ȃY[l̕擾
    Void SetZoom(SInt16 value);     // Y[ݒ肷
};

#endif
